
import java.awt.*;
import java.applet.Applet;


public class Calc extends Applet {

        // Calculator buttons

        Button B1 = new Button("1");
        Button B2 = new Button("2");
        Button B3 = new Button("3");
        Button B4 = new Button("4");
        Button B5 = new Button("5");
        Button B6 = new Button("6");
        Button B7 = new Button("7");
        Button B8 = new Button("8");
        Button B9 = new Button("9");
        Button B0 = new Button("0");
        Button Bplus = new Button("+");
        Button Bmin = new Button("-");
        Button Bmul = new Button("*");
        Button Bdiv = new Button("/");
        Button Bequ = new Button("=");
        Button Bdec = new Button(".");
        Button Bclr = new Button("Clear");
        Button Bsgn = new Button("+/-");
        Button Bsqrt = new Button("Sqrt");
        Button Bpi = new Button("PI");
        Button Bfree1 = new Button("");
        Button Bfree2 = new Button("");
        Button Bfree3 = new Button("");
        Button Bfree4 = new Button("");
        Button Bfree5 = new Button("");
        Button Bfree6 = new Button("");


        // Calculator checkboxes for color selection

        CheckboxGroup radio = new CheckboxGroup();
        Checkbox White = new Checkbox("White",radio,true);
        Checkbox Green = new Checkbox("Green",radio,false);
        Checkbox Red = new Checkbox("Red",radio,false);

        // Calculator text field

        TextField T1 = new TextField("0",30);

        // Registers required for calculations

        double Operand1 = 0.0;
        double Operand2 = 0.0;
        int operator = 0;

        // Control flags
        boolean newOperand = true;

        // panels
        Panel A1;
        Panel A2;

public void init() {

        // Add two Panels to the applet
        // One for the display and one for the buttons

        A1 = new Panel();
        A2 = new Panel();
        setLayout(new BorderLayout());
        add("North",A1);
        add("South",A2);

        // Add text entry field to A1   

        A1.add(T1);
        
        // Add buttons to A2    

        A2.setLayout(new GridLayout(6,6));
        A2.add(Yellow);
        A2.add(Bsqrt);
        A2.add(Bx2);
        A2.add(Bfree1);
        A2.add(Green);
        A2.add(Bsgn);
        A2.add(Bfree2);
        A2.add(Blue);
        A2.add(B7);
        A2.add(B8);
        A2.add(B9);
        A2.add(Bclr);
        A2.add(Bfree3);
        A2.add(Bfree4);
        A2.add(B4);
        A2.add(B5);
        A2.add(B6);
        A2.add(Bmul);
        A2.add(Bdiv);
        A2.add(Bfree5);
        A2.add(B1);
        A2.add(B2);
        A2.add(B3);
        A2.add(Bplus);
        A2.add(Bmin);
        A2.add(Bfree6);
        A2.add(B0);
        A2.add(Bdec);
        A2.add(Bpi);
        A2.add(Bequ);

        // set the colors for the calculator

        A1.setBackground(Color.yellow);
        A2.setBackground(Color.yellow);        
}




public boolean action(Event evt, Object obj) {
          Color col;
        try {   
                 // operations events

                if(addDigit(evt.target)==true) return true;
                if(handleUnaryOperator(evt.target)==true) return true;
                if(handleOperator(evt.target)==true) return true;
                if (evt.target instanceof Checkbox) {
                if(White.getState() == true) 
                     col=Color.White;
                else if (Green.getState() == true)
                         col=Color.green;
                else
                         col=Color.Red;
                A1.setBackground(col);
                A2.setBackground(col);
                A1.repaint();
                A2.repaint();
                }
        }
        catch (Exception e) {
                // Ignore exceptions
                Operand1 = 0.0;
                Operand2 = 0.0;
                operator = 0;
        }

        return(false);
}




// Concat text to T1

private void concatText(String s) {
        if(newOperand) {
                T1.setText("");
                newOperand = false;
        }
        T1.setText(T1.getText().concat(s));
}

// Add next digit to text
private boolean addDigit(Object obj) {
        boolean flag = false;

        if(obj==B1) {
                concatText("1");
                flag = true;
        }
        else if (obj==B2) {
                concatText("2");
                flag = true;
        }
        else if (obj==B3) {
                concatText("3");
                flag = true;
        }
        else if (obj==B4) {
                concatText("4");
                flag = true;
        }
        else if (obj==B5) {
                concatText("5");
                flag = true;
        }
        else if (obj==B6) {
                concatText("6");
                flag = true;
        }
        else if (obj==B7) {
                concatText("7");
                flag = true;
        }
        else if (obj==B8) {
                concatText("8");
                flag = true;
        }
        else if (obj==B9) {
                concatText("9");
                flag = true;
        }
        else if (obj==B0) {
                concatText("0");
                flag = true;
        }
        else if (obj==Bdec) {
                concatText(".");
                flag = true;
        }
        return flag;
}


// Handle the operator
private boolean handleOperator(Object obj) {
        boolean flag = false;

        // Transfer number displayed to register
        Operand2 = Double.valueOf(T1.getText()).doubleValue();

        // Do operation
        switch(operator) {
        case 0:
                Operand1 = Operand2;
                break;
        case 1:
                Operand1 += Operand2;
                break;
        case 2:
                Operand1 -= Operand2;
                break;
        case 3:
                Operand1 *= Operand2;
                break;
        case 4:
                Operand1 /= Operand2;
                break;
        case 5:
                Operand1 = Operand2;
                break;
        case 6:
                Operand1 = Math.pow(Operand1, Operand2);
                break;
        }

        // Check new operator
        if(obj==Bplus) {
                operator = 1;
                flag = true;
        }
        else if(obj==Bmin) {
                operator = 2;
                flag = true;
        }
        else if(obj==Bmul) {
                operator = 3;
                flag = true;
        }
        else if(obj==Bdiv) {
                operator = 4;
                flag = true;
        }
        else if(obj==Bequ) {
                operator = 5;
                flag = true;
        }
        else if(obj==Bxy) {
                operator = 6;
                flag = true;
        }
        if(flag)  {
                newOperand = true;
                T1.setText((new Double(Operand1)).toString());
        }
        return flag;
}


// Handle unary operators
private boolean handleUnaryOperator(Object obj) {
        boolean flag = false;
        double x = 0;
        double y = 0;
        
        try {
                y = Double.valueOf(T1.getText()).doubleValue();
        }
        catch (Exception e) {
                // Do nothing
        }

        if (obj==Bclr) {
                T1.setText("0");
                flag = true;
        }
        else if (obj==Bsqrt) {
                x = Math.sqrt(y);
                flag = true;
        }
        if(flag) {
                newOperand = true;
                if(x==0.0) {
                        T1.setText("0");
                }
                else {
                        T1.setText(String.valueOf(x));
                }
        }
        return flag;
}
}
